;*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
;Title:  ConvStri.asm
;Author: IAO
;URL: 
;
;Description: To Create a file and Take an Address from the BIOS data area. 
;
;Created:  16-02-2006 Esp. (Eng. 02-16-2006)
;Finished: 01-03-2006 Esp. (Eng. 03-01-2006)
;Modified:  
;Email: rdpt465@yahoo.es
;Trabajando bin. (Working well)
;
;With a good help from MichaelW (www.masmforum.com)
;*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* 

;ML /c convstri.asm
;DosLnk /tiny convstri.obj,convstri.com;

.model tiny 
.386    					;Sin esto el push da error.

.data
FILE1	DB	'Addr.ini',0	;Nombre del Archivo.
buff 	DB  8 dup (24h )

.const
STDOUT EQU 1

.code  
org 100h

Main:
    push  	40h
    pop   	ES
    mov   	BX,08h  	;0h Serial port 
    mov   	AX,ES:[BX]

;=============================================
    lea 	DX,buff
    call 	IntToString
    call 	PrintString

;Para Crear el archivo Addr.ini.
;To Create File Addr.ini.
	mov		AH,3Ch		;Funcin de crear un archivo
	lea		DX, FILE1
	xor		CX,CX		;CX = 0
	int 	21h			;Accede al DOS
	mov 	BX,AX		;Identificador para BX 

	mov 	AX,4202h	;Mueve puntero de Archivo al Final
	xor 	CX,CX		;CX = 0
	xor 	DX,DX		;DX = 0
	int 	21h

;Para Escribir en el archivo Addr.ini.
;To Write File Addr.ini.
;
	mov		AH,40h		;Escribe BUF al Final del archivo
	mov   	SI,offset buff  
	call 	Strlen
	lea		DX,offset buff 	
	int		21h

;Para Cerrar el archivo Addr.ini. (!Muy Importante).
;To Close File Addr.ini. (Very Important).
;
	mov		AH,3Eh		;Funcin de cerrado del Archivo.
	int		21h			;Accede al DOS

;Termina Programa
    mov 	AX,4C00h	;Terminate program execution
    int 	21h

;=============================================

;Imprime la Cadena.
PrintString:
	mov   	ah, 40h
    mov   	bx, STDOUT
    mov   	si, offset buff
    call 	strlen    
    mov   	dx, offset buff
    int   	21h
 ret

;Dentro de la Cadena
IntToString:
    mov 	si,dx		;Mueve DX a SI (Source Index)
    mov 	cx,sp		;Mueve SP (Stack Pointer) a CX
  stiLoop:
    xor 	dx,dx		;Pone en cero a DX
    mov 	bx,10d		;Carga BX con 10 decimal.
    div 	bx			;Divide.

    add 	dl,'0'		;Suma 0 en  DL
    push 	dx

    cmp 	ax,01h		;Compara si AX = 1
    jl 		reversing
    jmp 	stiLoop		;Salta a stiLoop (Arriba)
  reversing:
    mov 	dx,si		;Mueve SI a DX
  popLoop:
    cmp 	cx,sp		;Compara CX con SP
    je 		popdone
    pop 	ax			
    mov 	byte ptr[si],al  ;<== added 'ptr' here
    inc 	si
    jmp 	popLoop		;Salta a popLoop
  popdone:
    mov 	byte ptr[si],0
 ret					;Retorna al call (Arriba)


; Load offset address of string buffer into SI before call
Strlen:    
    xor 	cx,cx        ; initialize length to zero
  @@:  
    cmp 	BYTE PTR [si],0  ; compare bytes until find null
    je  	@F			 ; Jump to the next @@:
    inc 	cx           ; increment length
    inc 	si           ; increment address
    jmp 	@B			 ; Jump to the previous @@:
  @@:
 ret


end Main

